// pages/pageIndex/pageIndex.js
var WxParse = require('../../wxParse/wxParse.js');
var app = getApp()
var config = {};
var miucms = require('../../utils/miucms.js');

Page({
    /**
     * 页面的初始数据
     */
    data: {
        loding: true,
        HKapartment: [],
        otherHousing: [],
        HKhousing: [],
        banner: [],
        service: '',
        servicename: '',
        video: '',
        screen_data: {},
        advListHKhousing: {},
        advListotherHousing: {},
        initState: false,
        unreadMessages: 0, // 底部我的图标 未读系统通知数量

        areaIndex: 0, // 

        tabValue: 0,
        swiperCurrent: 0, // 新轮播图 滚动的下标
        topTitle: "",
        areaPopState: false, // 区域找房的弹窗 状态
        areaPopId: 0, //  区域 选中
        areaPopList: [], // 地区选项选中 数据
        getLocationList: [], // 地区选项 配置数据

        listData: [], // 列表数据
        listPage: 1, // 列表数据 页数
        listDataLeft: [], // 列表数据
        listDataRight: [], // 列表数据
        listType: "", // 推荐列表类型
        pagevalue: null, // 推荐列表的 value
        showTOTOP: false, // 返回顶部按钮状态

        HeadSwiperHeight: 0, // 轮播图的最高度
        isNewVersions: true,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    timer: null,
    onLoad: function (options) {
        // this.getLocationData()

        wx.showLoading()
        this.get_config()
    },

    // 获取系统通知数量
    getNoticeNumber() {
        if (app.globalData.unreadMessagesState) return
        miucms.count().then(res => {
            this.setData({
                unreadMessages: res.data.count
            })
        })
    },

    get_config() {
        var that = this;
        this.setData({
            screen_data: app.globalData.screen_data,
            bottomLift: app.globalData.screen_data.bottomLift,
        })
        // if (app.globalData.code) {
        if (app.globalData.config && app.globalData.config.lists) {
            // this.get_list();
            this.getNewInit()
            this.setData({
                initState: true
            })
            this.getTopTitle()

            this.ratio = app.globalData.screen_data['windowWidth'] / 750

        } else {
            setTimeout(function () {
                that.get_config()
            }, 10)
        }
    },
    getTopTitle() {
        miucms.getTopTitle(this, app)
    },

    // 新初始化数据
    getNewInit() {
        miucms.wxget(`${app.globalData.baseURL}/tenement/v2/api/home`).then(res => {
            let data = res.data
            // console.log(data);
            let {
                recommendedTab
            } = data

            let listType = ""
            recommendedTab.forEach(el => {
                //     if (el.type == 'recommend') el.select = false
                //     if (el.type == 'wholelease') el.select = true
                if (el['select']) listType = el['type']
            })

            this.setData({
                ...data,
                listType,
                loding: false
            })
            this.getListData()
        })

    },

    get_list() {
        return
        var that = this;
        miucms.request('https://app.gter.net/tenement/home', {}).then(data => {
            let advListHKhousing = {},
                advListotherHousing = {};
            if (data.data.advList && data.data.advList.HKhousing && data.data.advList.HKhousing.length > 0) {
                data.data.advList.HKhousing.forEach(item => {
                    advListHKhousing[item.position + ''] = Object.assign({}, item)
                })
            }
            if (data.data.advList && data.data.advList.otherHousing && data.data.advList.otherHousing.length > 0) {
                data.data.advList.otherHousing.forEach(item => {
                    advListotherHousing[item.position + ''] = Object.assign({}, item)
                })
            }

            let findHouseSource = data.data.findHouseSource

            findHouseSource.forEach(element => {
                if (Array.isArray(element['rent'])) element['rent'] = `${element['rent'][0]} ~ ${ element['rent'][1] }`
            })

            // data.data.banner[0]
            data.data.banner[0]['finderUserName'] = "sphnKNr2yUjovYn"
            data.data.banner[0]['feedId'] = "export/UzFfAgtgekIEAQAAAAAA2WM6nDqilAAAAAstQy6ubaLX4KHWvLEZgBPEnIFMGRgfQe-HzNPgMJovs0j3nb0lBUSqGdvZ_3I-"
            console.log(data.data.banner[0]);

            that.setData({
                    HKapartment: data.data.HKapartment,
                    otherHousing: data.data.otherHousing,
                    findHouseSource,
                    HKhousing: data.data.HKhousing,
                    banner: data.data.banner,
                    service: data.data.service,
                    servicename: data.data.servicename,
                    advListHKhousing,
                    advListotherHousing,
                    loding: false
                },
                function () {
                    wx.hideLoading()
                    that.getNoticeNumber()
                })
        }).catch(res => {})
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {
        return {
            title: this.data.topTitle
        }
    },
    copy() {
        // const content = 'GTservice';
        // const content = 'Gternet2';
        const content = this.data.servicename;
        miucms.copy(content).then((res) => {}).catch(err => {})
    },
    play(e) {
        this.setData({
            video: e.detail.src
        })
    },
    closePage(e) {
        this.setData({
            video: ''
        })
    },
    // 关闭广告
    closeAd(e) {
        let {
            position,
            world,
            id
        } = e.detail;
        if (world) {
            delete this.data.advListotherHousing[position];
            this.setData({
                advListotherHousing: this.data.advListotherHousing
            })
        } else {
            delete this.data.advListHKhousing[position];
            this.setData({
                advListHKhousing: this.data.advListHKhousing
            })
        }
        miucms.closeAD(id)
    },
    // 点击广告
    clickAD(e) {
        miucms.clickAD(e.detail.id)
    },

    setValue(e) {
        let key = e.currentTarget.dataset.key
        let value = e.currentTarget.dataset.value
        this.setData({
            [key]: value
        })
    },

    // 公共跳转
    publicJumps(e) {
        let url = e.currentTarget.dataset.url
        wx.navigateTo({
            url,
        })

    },

    // 新 轮播图 自动滑动事件，修改下标
    bindchangeSwiper(e) {
        let current = e.detail.current
        this.setData({
            swiperCurrent: current
        })
    },

    // 新 轮播图 点击事件
    handleSwiper(e) {
        let {
            appid,
            url,
            statid,
            finderusername,
            feedid,
            type,
            advertisingtype
        } = e.currentTarget.dataset

        // miucms.request(app.globalData.config.FormidInsert, {
        let requestUrl = advertisingtype == 'slideshow' ? `${app.globalData.baseURL}/tenement/v2/api/ad/click` : app.globalData.config.FormidInsert
        // miucms.request(app.globalData.baseURL + '/tenement/v2/api/ad/click', {
        miucms.request(requestUrl, {
            statid
        }).then(res => {})

        // 跳转视频号
        if (type == 5) {
            wx.openChannelsActivity({
                finderUserName: finderusername,
                feedId: feedid
            })
            return false
        }

        // 跳转直播
        if (type == 4) {
            wx.openChannelsLive({
                finderUserName: finderusername
            })
            return false
        }

        // 判断跳转小程序
        if (appid) {
            wx.navigateToMiniProgram({
                appId: appid,
                path: url
            })
            return false;
        }

        // 判断是否是h5页面的
        if (url && url.indexOf('http') != -1) {
            wx.navigateTo({
                url: `/pages/webViewwebweb/index?url=${ url }`,
            })
            return false;
        }

        if (url) {
            wx.navigateTo({
                url: '/' + url,
            })
            return false;
        }
    },

    // 新 点击 搜索
    search(e) {
        let value = e.detail.value
        console.log(value);
    },

    // 打开 区域找房 的 弹窗
    openAreaPop(e) {
        let areaPopId = e.currentTarget.dataset.id
        this.setData({
            areaPopId,
            areaPopList: [],
            areaPopState: !this.data.areaPopState
        })

        if (this.data.getLocationList.length == 0) this.getLocationData()
    },

    // 获取
    getLocationData() {
        miucms.request(app.globalData.baseURL + "/tenement/v2/api/home/getLocationData").then(res => {
            let data = res.data
            let obj = {}
            for (const key in data) {
                // 判断是否是整数
                if ((key ^ 0) == key) {
                    obj[key] = {}
                    obj[key]['name'] = data[key]
                } else {
                    if (!obj[key ^ 0]['data']) obj[key ^ 0]['data'] = []

                    obj[key ^ 0]['data'].push({
                        key,
                        name: data[key],
                        pitch: false,
                    })
                }
            }

            this.setData({
                getLocationList: obj
            })
        })
    },

    // 跳转个人列表
    skipPersonList(e) {
        let {
            key,
            id
        } = e.currentTarget.dataset
        wx.navigateTo({
            url: `/pages/personList/personList?${key}=${id}`,
        })
    },

    // 处理点击
    areaPopItem(e) {
        let {
            key,
            index
        } = e.currentTarget.dataset
        let areaPopList = this.data.areaPopList
        let getLocationList = this.data.getLocationList
        let areaPopId = this.data.areaPopId
        const indexOf = areaPopList.indexOf(key)
        if (indexOf === -1) {
            areaPopList.push(key)
            getLocationList[areaPopId].data[index].pitch = true
        } else {
            areaPopList.splice(indexOf, 1)
            getLocationList[areaPopId].data[index].pitch = false
        }
        this.setData({
            areaPopList,
            getLocationList
        })
    },

    areaPopItemUnlimited(e) {
        let {
            areapopid
        } = e.currentTarget.dataset
        let areaPopId = this.data.areaPopId
        let getLocationList = this.data.getLocationList
        getLocationList[areaPopId].data.forEach(el => {
            el.pitch = false
        })

        this.setData({
            getLocationList,
            areaPopList: []
        })

        if (areapopid >= 0) {
            this.setData({
                areaPopId: areapopid
            })
        }

    },

    // 处理区域找房弹窗的确定
    handleAreaPopConfirm() {
        let areaPopList = this.data.areaPopList
        let areaPopId = this.data.areaPopId

        if (areaPopList.length == 0) areaPopList = [areaPopId]

        wx.navigateTo({
            url: `/pages/personList/personList?location=${areaPopList}`,
        })
    },

    // 切换 tab
    cutTab(e) {
        let {
            index,
            type
        } = e.currentTarget.dataset

        if (type == this.data.listType) return

        let recommendedTab = this.data.recommendedTab
        let pagevalue = ""
        recommendedTab.forEach(el => {
            el['select'] = false
            // if (el.type == type) pagevalue = el['pagevalue']
        })
        recommendedTab[index]['select'] = true
        this.setData({
            recommendedTab,
            listDataLeft: [],
            listDataRight: [],
            listType: type,
            listPage: 0,
            pagevalue: 0,
        })
        this.leftHeight = 0
        this.rightHeight = 0
        this.getListData()
    },

    // 获取列表数据
    getListData() {
        if (this.getListDataState) return
        this.getListDataState = true
        wx.showLoading({
            title: '加载中...',
        })

        miucms.wxget(app.globalData.baseURL + "/tenement/v2/api/home/recommendList", {
            page: this.data.listPage,
            limit: 20,
            type: this.data.listType,
            pagevalue: this.data.pagevalue || 0,
        }).then(res => {
            // this.getListDataState = false

            if (res.code != 200) return
            let data = res.data.data

            let pagevalue = res.data.pagevalue
            let recommendedTab = this.data.recommendedTab


            this.setData({
                listPage: this.data.listPage + 1,
                listData: data,
                pagevalue,
                recommendedTab
            })

            this.listDataIndex = 0
            this.calculateProcessingCenter()

        }).catch(() => {
            this.getListDataState = false
        }).finally(() => {
            wx.hideLoading()
        })
    },

    listDataIndex: 0,
    leftHeight: 0, // px 单位
    rightHeight: 0,
    ratio: 0,

    // 计算
    calculateProcessingCenter() {
        let ratio = this.ratio
        if (this.ratio) this.ratio = this.data.screen_data['windowWidth'] / 750
        let targetData = this.data.listData[this.listDataIndex]
        if (!targetData) {
            this.getListDataState = false
            return
        }
        let type = targetData['type']
        if (type == 'adv') {
            this.getPictureHeight(targetData.image).then(res => {
                targetData['imageLocal'] = res.path
                this.whichSide(res.actual, targetData)
                return
            })
        } else {
            let altitude = 0 // rpx
            if (type == 'apartment') {
                altitude = 205
                if (targetData['specifications'].length > 2) altitude += 100
                else altitude += 64 * targetData['specifications'].length
            } else altitude = 141

            altitude = altitude * ratio // 转 px

            this.setData({
                targetData
            })

            altitude += (150 / 180 * 337.5 * ratio)

            let select = type == 'apartment' ? '#apartment' : '#general'

            let query = wx.createSelectorQuery();
            query.select(select).boundingClientRect(rect => {
                let height = rect.height;
                altitude += height
                this.whichSide(altitude, targetData)
            }).exec();

        }

    },

    // 判断在哪边的
    whichSide(res, targetData) {
        if (this.leftHeight <= this.rightHeight) {
            this.leftHeight = this.leftHeight + res
            this.data.listDataLeft.push(targetData)
        } else {
            this.rightHeight = this.rightHeight + res
            this.data.listDataRight.push(targetData)
        }

        this.setData({
            listDataLeft: this.data.listDataLeft,
            listDataRight: this.data.listDataRight
        })


        if (this.data.listData[this.listDataIndex]) {
            this.listDataIndex++
            this.calculateProcessingCenter()
        }
    },

    // 获取图片高度
    getPictureHeight(src) {
        return new Promise((resolve, reject) => {
            wx.getImageInfo({
                src,
                success: res => {
                    let {
                        width,
                        height,
                        path
                    } = res
                    let actual = height / width * 337 * this.ratio
                    resolve({
                        actual,
                        path
                    })
                }
            })
        })
    },


    // 上拉到底部
    onReachBottom() {
        this.getListData()
    },

    onPageScroll(e) {
        if (e.scrollTop > 1000 && !this.data.showTOTOP) {
            this.setData({
                showTOTOP: true
            })
        } else if (e.scrollTop < 1000 && this.data.showTOTOP) {
            this.setData({
                showTOTOP: false
            })
        }
    },

    // 轮播图的加载事件
    loadHeadSwiper(e) {
        let ratio = app.globalData.screen_data['windowWidth'] / 750
        let originalWidth = e.detail.width;
        let originalHeight = e.detail.height;
        let height = originalHeight / originalWidth * 690 * ratio

        if (height > this.data.HeadSwiperHeight) {
            this.setData({
                HeadSwiperHeight: height
            })
        }


    },

})