// template/listOperations/listOperations.js

Component({
    /**
     * 组件的属性列表
     */
    properties: {
        brands: Object,
        roomtype: Object,
        roomlistings: Object,
        screen_data: Object,
        money: Object,

        operationstype: {
            type: String,
            observer(res) {
                let conditionAllConfig = this.data.conditionAllConfig

                this.setData({
                    conditionObj: conditionAllConfig[res]
                })

                console.log("conditionObj", this.data.conditionObj);
            }
        },
        location: Object,

    },

    /**
     * 组件的初始数据
     */
    data: {
        conditionState: "school", // brand  rent house  floor  school
        conditionAllConfig: {
            student: {
                brand: {
                    name: "品牌",
                    valueKey: "brands"
                },
                rent: {
                    name: "租金",
                },
                house: {
                    name: "房型",
                    valueKey: "roomtype"
                },
                floor: {
                    name: "楼型",
                    valueKey: "roomlistings"
                },
            },
            housing: {
                school: {
                    name: "区域",
                    valueKey: "brands"
                },
                types: {
                    name: "出租方式",
                    valueKey: "types"
                },
                rent: {
                    name: "租金",
                },
                moreCondition: {
                    name: "更多",
                    valueKey: "brands"
                },
                orderby: {
                    name: "最新",
                    valueKey: "brands"
                },
            }
        },

        conditionObj: {},

        rent: {
            min: 1000,
            max: 50000,
            rate: 490,
            defaultMin: 50, // 
            defaultMax: 80,
            step: 100,
            for: 491
        },

        rentValue: [40, 80],

        areaState: "area", // area school
    },

    /**
     * 组件的方法列表
     */
    methods: {
        setValue(e) {
            let {
                key,
                value
            } = e.currentTarget.dataset
            this.setData({
                [key]: value
            })
        },

        changeItem(e) {
            let conditionState = this.data.conditionState
            let {
                value,
            } = e.currentTarget.dataset

            let conditionObj = this.data.conditionObj
            let valueKey = conditionObj[conditionState].valueKey
            let obj = this.data[valueKey].obj
            conditionObj[conditionState]['valueText'] = obj[value]

            this.triggerEvent('submit', {
                type: conditionState,
                value
            })

            this.setData({
                conditionState: "",
                conditionObj
            })
        },

        // 滑动租金数据 事件
        bindChangeRent(e) {
            let value = e.detail.value
            this.setData({
                rentValue: value
            })
        },

        // 处理 租金的 事件
        handleRant(e) {
            let type = e.currentTarget.dataset.type
            let conditionState = this.data.conditionState
            let rentValue = this.data.rentValue
            let rent = this.data.rent
            rentValue.sort()
            let rent_min = 0
            let rent_max = 0
            let conditionObj = this.data.conditionObj
            if (type != 'unlimited') {
                rent_min = (rentValue[0] * rent['step']) + rent['min']
                rent_max = (rentValue[1] * rent['step']) + rent['min']
                conditionObj[conditionState]['valueText'] = `${rent_min} ~ ${rent_max}`
            }

            this.triggerEvent('submit', {
                type: conditionState,
                rent_min,
                rent_max,
            })

            this.setData({
                conditionState: "",
                conditionObj
            })
        },
    }
})